<template>
  <el-main>
    <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
      <el-row>
        <el-col :span="12">
          <el-form-item label="文号" :label-width="formLabelWidth">
            <el-input v-model="form.unitName" placeholder="_______罚告〔     〕第    号"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="当事人姓名" :label-width="formLabelWidth">
            <el-input v-model="form.litigant" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="案由" :label-width="formLabelWidth">
        <el-input v-model="form.unlawfulAct" autocomplete="off"></el-input>
      </el-form-item>
<el-row>
  <el-col :span="12">
    <el-form-item label="违反规定" :label-width="formLabelWidth">
      <el-autocomplete
        v-model="form.deregulation"
        filterable
        style="width: 100%"
        :fetch-suggestions="querySearchHandle"
        placeholder="请输入内容"
        :trigger-on-focus="false"
        @select="handleSelectOne"
      >
      </el-autocomplete>
    </el-form-item>
  </el-col>
  <el-col :span="12">
    <el-form-item label="条" :label-width="formLabelWidth">
      <el-select v-model="form.deregulationTiao" placeholder="请选择条" style="width: 100%">
        <el-option
          v-for="item in lawTiaoList"
          :label="item.lawTiaoName"
          :value="item.lawTiaoName"
        >
        </el-option>
      </el-select>
    </el-form-item>
  </el-col>
</el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="款" :label-width="formLabelWidth">
            <el-input v-model="form.deregulationKuan"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="项" :label-width="formLabelWidth">
            <el-input v-model="form.deregulationXiang"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
<el-row>
  <el-col :span="12">
    <el-form-item label="法律依据条款" :label-width="formLabelWidth">
      <el-autocomplete
        v-model="form.stipulate"
        filterable
        style="width: 100%"
        :fetch-suggestions="querySearchHandle"
        placeholder="请输入内容"
        :trigger-on-focus="false"
        @select="handleSelectTwo"
      >
      </el-autocomplete>
    </el-form-item>
  </el-col>
  <el-col :span="12">
    <el-form-item label="条" :label-width="formLabelWidth">
      <el-select v-model="form.stipulateTiao" placeholder="请选择条" style="width: 100%">
        <el-option
          v-for="item in lawTiaoList"
          :label="item.lawTiaoName"
          :value="item.lawTiaoName"
        >
        </el-option>
      </el-select>
    </el-form-item>
  </el-col>
</el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="款" :label-width="formLabelWidth">
            <el-input v-model="form.stipulateKuan"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="项" :label-width="formLabelWidth">
            <el-input v-model="form.stipulateXiang"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="处罚内容" :label-width="formLabelWidth">
        <el-input type="textarea" :row="2" v-model="form.penaltyContent" autocomplete="off"></el-input>
      </el-form-item>

      <el-form-item label="处罚理由和依据" :label-width="formLabelWidth">
        <el-input type="textarea" :row="2" v-model="form.penaltyReason" autocomplete="off"></el-input>
      </el-form-item>

      <el-form-item label="行政处罚" :label-width="formLabelWidth">
        <el-input type="textarea" :row="2"
          v-model="form.administrativePenalty"
          autocomplete="off"
        ></el-input>
      </el-form-item>

      <el-form-item label="说明:" :label-width="formLabelWidth">
        <el-checkbox-group v-model="form.explanations" @change="changenull">
          <el-checkbox label="0" name="type">
            根据《中华人民共和国行政处罚法》第四十五条第一款的规定，你（单位）有权进行陈述、申辩。<br>
            请你（单位）自收到本告知书之日起<el-input v-model="form.deadline" style="width: 10% !important"></el-input>日内
            <p>日内向我机关提出陈诉和申辩，逾期未提出的，视为放弃此权利。</p>
            <p>如果充分认可本机关告知的处罚内容及事实、理由和依据，你（单位）有权放弃陈述和申辩权利，</p>
            <p>填写《放弃权利申请书》。</p>
          </el-checkbox>
          <el-checkbox label="1" name="type">
            根据《中华人民共和国行政处罚法》第六十三条、六十四条的规定，对上述拟作出的行政处罚，<br>
            你（单位）有要求举行听证的权利。如果要求举行听证，请在收到本告知书之日起五日内以书面<br>
            或口头形式提出举行听证的要求，逾期未提出的，视为放弃此权利。
          </el-checkbox>
        </el-checkbox-group>
      </el-form-item>

      <el-form-item label="单位地址" :label-width="formLabelWidth">
        <el-input v-model="form.address" autocomplete="off"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="联 系 人" :label-width="formLabelWidth">
            <el-input v-model="form.phoneName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话" :label-width="formLabelWidth">
            <el-input v-model="form.phone" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="邮政编码" :label-width="formLabelWidth">
            <el-input v-model="form.postcode" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="告知日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.dateTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center;">
      <el-button v-show="form.registerState != '1'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-show="form.registerState != '1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import {getLaw, lawInfo} from '@/api/lawList/lawList';
import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/advanceNotice";
import moment from "moment";

export default {
  name: "advanceNotice",
  props: ['isShowYulan','id','isFinish','processId','title'],
  components: {
    WordView
  },
  data() {
    return {
      showView: false,
      form: {
        unitName: "",
        litigant: "",
        unlawfulAct: "",
        deregulation: "",
        stipulate: "",
        penaltyContent: "",
        administrativePenalty: "",
        address: "",
        phoneName: "",
        phone: "",
        postcode: "",
        dateTime: "",
        penaltyReason:"",
        deadline:"",
        explanations:[]
      },
      lawList: [],
      lawTiaoList: [],
      formLabelWidth: "140px",
    };
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
        if (res.data.code == 0) {
          // 转换null为""
          let v = res.data.data;
          for (let attr in v) {
            if (v[attr] == null) {
              v[attr] = "";
            }
          }
          let str = JSON.stringify(v);
          let data = JSON.parse(str);
          this.form = data;
        }
      });
    },
    changenull(val){
      console.log(val,'val--==')
      if(val.length==0){
        this.form.deadline ='';
      }else if(val.length==1) {
        if (val[0] == '1') {
          this.form.deadline = '';
        }
      }
    },
    querySearchHandle(queryString, cb) {  //模糊搜素
      getLaw(queryString).then(res => {
        this.lawList = []
        let resultList = res.data.data
        resultList.forEach(item => {
          this.lawList.push({
            value: item.name,
            id: item.id
          })
        })
        cb(this.lawList)
      })
    },
    handleSelectOne(item) {
      this.form.deregulation = item.value
      this.form.lawId = item.id
      lawInfo(item.value).then(res => {
        this.lawTiaoList = res.data.data
      })
    },
    handleSelectTwo(item){
      this.form.stipulate = item.value
      this.form.lawId = item.id
      lawInfo(item.value).then(res => {
        this.lawTiaoList = res.data.data
      })
    },
    dataFormSubmit(type) {
      console.log(type)
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      console.log(this.title)
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/advanceNotice.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);

      WordView.methods.exportDoc(wordData, "/wordes/advanceNotice.docx", this.title+'.docx');
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);

      let str = data.explanations;
      if (str.indexOf("0") >= 0){
        data.aa = true;
        data.bb = false;
      }else {
        data.aa = false;
        data.bb = true;
      }
      if (str.indexOf("1") >= 0){
        data.cc = true;
        data.dd = false;
      }else {
        data.cc = false;
        data.dd = true;
      }
      if (data.dateTime != '' && data.dateTime != null) {
        data.dateTime = moment(data.dateTime).format('YYYY年MM月DD日');
      }else {
        data.dateTime = '  年  月  日'
      }

      return data;
    }
  }
}
</script>

<style scoped>

</style>
